/*    
    Copyright (C) 2006  Andrea Detti, Claudio Loreti, Remo Pomposini
    This file is part of "Obamp Proxy",

    "Obamp Proxy" is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    "Obamp Proxy" is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Foobar; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
    
*/

import java.io.*;
import java.awt.*;


public class CollabTool extends Frame {
  protected static int id = 0;
	
	protected Label label1, label2, label3, label4, label5, label6, label7, label8, label9, label10, label11, label12, label13;
    protected TextField textField1, textField2, tree1, tree2, tree3, tree4, tree5, tree6, tree7, tree8, tree9, tree10;
    protected TextArea outputArea1, outputArea2;
    protected Button button1, button2, button3, button4, button5, button6;
    protected Checkbox sig_dump_box;
    protected Panel imagePanel;
    
    public Signalling sig;
    protected Stato state;
    protected DataManager dm;
    protected Image logo;
    protected Toolkit toolkit;
    protected Graphics graphics; 
    
	
		    
  public CollabTool ( String arg[] ) throws IOException {
    super ("OBAMP Proxy");
    super.setResizable(true);
    toolkit = Toolkit.getDefaultToolkit();
    Interfaccia();
    
  }
  
  public void update( Graphics g) {
	   paint(g);
	   }

  public void paint(Graphics g) {
	  //g.drawImage(logoRadiolabs, 300, 55, this);
	  g.drawImage(logo, 20, 500, this);
    }
 
  public void Interfaccia() {
	  		
	this.setLayout(null);
	this.setBackground(Color.decode("#D3D3D3"));//#CCFFFF
	
    try {
    	MediaTracker mt1 = new MediaTracker (this);
    	logo = Toolkit.getDefaultToolkit().createImage("./image/logo.gif");
        mt1.addImage(logo, 0);
		mt1.waitForID(0);
	} catch (InterruptedException e) {
		e.printStackTrace();
	}
    
	sig_dump_box = new Checkbox();
	sig_dump_box.setBounds(171,70,10,10);
	add(sig_dump_box);
	
	label3 = new Label("Control message dump");
    label3.setBounds(20, 70, 150, 15);
    this.add(label3);
    
    outputArea1 = new TextArea("", 0, 0, 1);
    outputArea1.setBounds(20, 90, 460, 250);
    this.add(outputArea1);
    
    label4 = new Label("Neighbors Table");
    label4.setBounds(20, 350, 150, 15);
    this.add(label4);
    
    outputArea2 = new TextArea("", 0, 0, 3);
    outputArea2.setBounds(20, 370, 460, 120);
    this.add(outputArea2);
    
    label5 = new Label("Core Id:"+"0");
    label5.setBounds(220, 40, 250, 15);
    this.add(label5);
    
    label6 = new Label("Parent Id:"+"0");
    label6.setBounds(220, 55, 250, 15);
    this.add(label6);
    
	button1 = new Button("Join");
    button1.setBounds(30, 40, 80, 25);
    this.add(button1);
    
    setSize(500, 560);
    setVisible(true);
        
	}
	
//--------------------------------------------------

	public boolean handleEvent(Event event) {
		
        if (event.id == Event.WINDOW_DESTROY) {
        	setVisible(false);         // hide the Frame
            dispose();      // tell windowing system to free resources
            System.exit(0); // exit
            return true;
        }
        if (event.target == button1 && event.id == Event.ACTION_EVENT && sig==null) {
            button1_Clicked(event);
        } 
        return super.handleEvent(event);
    }
    
//--------------------------------------------------

	void button1_Clicked(Event event) {
     	try {
     	sig = new Signalling();
     	sig.setTextArea(outputArea1, outputArea2,label5,label6,sig_dump_box);
     	dm = new DataManager();
    	dm.setTextArea(outputArea1);
    	dm.setSignalling(sig);
        
    	} catch (Exception ex) {
           		ex.printStackTrace ();
        }
    	
    }
    
	static public void main (String args[]) throws IOException { 
	                                                             
   	new CollabTool( args );
   	                                     
  	  	
  }
  
}














