package Multicast;

import java.net.*;
import prominence.msg.*;


public class OverlayNeighbor {
  
  public byte IP;
  public InetAddress IPAddress;
  public int port;
  public MessageOutput mo;
  public boolean istree;//it identifies if it is a link of tree
  public int Number_of_TCS;//if it is 0 i have not already receaved a tree create: anybody can't delete it 
  public double DelayBudget;
  public byte TCSN;  
  public long Texpire;
  public double PingInterval;
  public int distance; //distance in hops from the node
  //public byte distance; //distance in hops from the node
  public byte last_ack_sn;
  public byte last_nack_sn;
  public byte last_nack_conf_sn;
  public byte last_conf_sn;
  public byte hello_seq_num;
  public byte fast_hello_seq_num;
  public boolean is_my_nearest;
  public boolean fast_hello;
  public InetAddress CoreAddress;
  public long last_pkt_sent_time;
  public long last_pkt_recv_time;
  public long last_failure_time;
  
    
  public OverlayNeighbor (byte IP_, InetAddress IPAddress_, int porta, long Texpire_) {
  	
  	IP = IP_;
  	IPAddress = IPAddress_;
    port = porta;
    istree = false;
    Number_of_TCS = 0;
 	DelayBudget = 0;
 	TCSN = 0;
 	Texpire = Texpire_;
    PingInterval = 0;
    last_ack_sn = 0;
    last_nack_sn = 0;
    last_nack_conf_sn = 0;
    last_conf_sn = 0;
    distance = 4;
    hello_seq_num = 0;
    fast_hello_seq_num = 0;
    fast_hello = false;
    CoreAddress = null;
    last_pkt_sent_time = 0;
    last_pkt_recv_time = 0;
    last_failure_time = -1000;
 	
  }
    	
  public OverlayNeighbor (byte IP_, InetAddress IPAddress_, int porta, MessageOutput o, long Texpire_) {
    
    IP = IP_;
    IPAddress = IPAddress_;
    port = porta;
    mo = o;
    istree = false;
    Number_of_TCS = 0;
    DelayBudget = 0;
    TCSN = 0;
    Texpire = Texpire_;
    PingInterval = 0;
    last_ack_sn = 0;
    distance = 4;
    hello_seq_num = 0;
    fast_hello = false;
    last_pkt_sent_time = 0;
    last_pkt_recv_time = 0;
    last_failure_time = -1000;
    
  }
  
  public OverlayNeighbor (byte IP_, InetAddress IPAddress_) {
	  	
	  	IP = IP_;
	  	IPAddress = IPAddress_;
	    istree = false;
	    Number_of_TCS = 0;
	 	DelayBudget = 0;
	 	TCSN = 0;
	 	last_ack_sn = 0;
	    last_nack_sn = 0;
	    last_nack_conf_sn = 0;
	    last_conf_sn = 0;
	    distance = 4;
	    hello_seq_num = 0;
	    fast_hello_seq_num = 0;
	    fast_hello = false;
	    last_pkt_sent_time = 0;
	    last_pkt_recv_time = 0;
	    last_failure_time = -1000;
	 	
	  }
  
  public OverlayNeighbor (InetAddress IPAddress_) {
	  	
	  	IPAddress = IPAddress_;
	    istree = false;
	    Number_of_TCS = 0;
	 	DelayBudget = 0;
	 	TCSN = 0;
	 	last_ack_sn = 0;
	    last_nack_sn = 0;
	    last_nack_conf_sn = 0;
	    last_conf_sn = 0;
	    distance = 4;
	    hello_seq_num = 0;
	    fast_hello_seq_num = 0;
	    fast_hello = false;
	    last_pkt_sent_time = 0;
	    last_pkt_recv_time = 0;
	    last_failure_time = -1000;
	 	
	  }
   
  public InetAddress GetIPaddress(){
    	return IPAddress;
  }
  
  public int GetPortNumber(){
    	return port;
  }
  
  public MessageOutput GetMessageOutput(){
    	return mo;
  }
  
  public boolean istreeValue(){
    	return istree;
  }
    
  public void SetIPaddress(InetAddress IPaddress_){
	  IPAddress = IPaddress_;
  	
  }
  
  public void SetPortNumber(int port_){
    	port = port_;
  }
  
  public void SetMessageOutput(MessageOutput o){
    	mo = o;
  }
  
  public void Setistree(boolean value){
    	istree = value;
  }
  
  public void ResetNumberTCS(){
    	Number_of_TCS = 0;
  }
  
  public void Reset() {
	  	istree = false;
	    Number_of_TCS = 0;
	 	TCSN = 0;
	 	last_ack_sn = 0;
	    last_nack_sn = 0;
	    last_nack_conf_sn = 0;
	    last_conf_sn = 0;
	    distance = 4;
	    hello_seq_num = 0;
	    fast_hello_seq_num = 0;
	    fast_hello = false;
	    last_pkt_sent_time = 0;
	    last_pkt_recv_time = 0;
	    last_failure_time = -1000;
  }
   
}